#include "Plotter.h"

// other includes (have to come after root includes)
#include <iostream>

using namespace AWPlotter;
using namespace std;

namespace
{
    PlotterPtr plotter(new Plotter());
    vector<double>  X;
    vector<double>  Y;
    TRandom *r3 = new TRandom3();
}

//called from a thread
void* thePlotter(void *args)
{
    double cnt = 0;

    while (plotter->start())
    {
        double val = r3->Gaus();
        cnt        = cnt + 0.01;

        X.push_back(cnt);
        Y.push_back(val);

        plotter->plotHistogram(val);
        plotter->plotScatter(X, Y);

        TThread::Sleep(0, 300000000);     //300ms
    }

    std::cout << " We exit thread thePlotter\n";

    return 0;
}

int main(int argc, char **argv)
{
    TApplication theApp("App", &argc, argv);

    plotter->init(20);
    plotter->pad(1)->Connect("Closed()", "TApplication", &theApp, "Terminate()"); 
    plotter->pad(2)->Connect("Closed()", "TApplication", &theApp, "Terminate()"); 

    TThread *th1 = new TThread("th1", thePlotter);
    th1->Run();

    try
    {
        theApp.Run(kTRUE);
    }
    catch (...)
    {
        int iDum = 0;
    }

    plotter->setStart(false);
    TThread::Sleep(0, 700000000);     //700ms

    th1->SetCancelAsynchronous();
    th1->Kill();

    std::cout << " We exited\n";

    return 0;
}
